from django.db import models
from django.core.validators import MaxValueValidator, MinValueValidator

# Create your models here.

class Student(models.Model):
    first_name = models.CharField(max_length=30 , default= 'firstName')
    last_name = models.CharField(max_length=30 , default= 'lastName')
    def __str__(self):
        return self.first_name +" "+ self.last_name


class Professor(models.Model):
    first_name = models.CharField(max_length=30 , default= 'firstName')
    last_name = models.CharField(max_length=30 , default= 'lastName')
    phone_number = models.IntegerField(default = 0)
    def __str__(self):
        return self.first_name +" "+ self.last_name

class Exam(models.Model):
    topic = models.CharField(max_length=100 , default = 'Topic')
    students = models.ManyToManyField(Student, null=True)
    docent = models.ForeignKey(Professor, on_delete=models.CASCADE , null=True)
    def __str__(self):
        return  self.topic

class Grade(models.Model):
    grade = models.FloatField(
        validators = [MinValueValidator(1.0) , MaxValueValidator(5.0)] , default = 0.0
    )
    exam = models.ForeignKey(Exam,on_delete= models.CASCADE , null= True)
    student = models.ForeignKey(Student, on_delete = models.CASCADE , null=True)
    def __str__(self):
        return self.student.__str__() + " got " + self.grade.__str__() + " in " + self.exam.__str__()
    

